<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Entity;

use DateTime;
use DateTimeInterface;
use Doctrine\ORM\Mapping as ORM;
use Sylius\Component\Core\Model\AdminUserInterface;

/**
 * @ORM\Entity
 *
 * @ORM\Table(name="dedi_sylius_quote_plugin_internal_comment")
 */
class InternalComment implements InternalCommentInterface
{
    /**
     * @ORM\Id
     *
     * @ORM\GeneratedValue(strategy="AUTO")
     *
     * @ORM\Column(type="integer", nullable=false, name="id")
     */
    protected ?int $id = null;

    /**
     * @ORM\ManyToOne(targetEntity="Dedi\SyliusQuotePlugin\Entity\QuoteInformationInterface", inversedBy="internalComments")
     *
     * @ORM\JoinColumn(name="quote_information_id", referencedColumnName="id", nullable=false)
     */
    protected ?QuoteInformationInterface $quoteInformation = null;

    /**
     * @ORM\ManyToOne(targetEntity="Sylius\Component\Core\Model\AdminUserInterface")
     *
     * @ORM\JoinColumn(name="user_id", referencedColumnName="id", nullable=false)
     */
    protected ?AdminUserInterface $user;

    /** @ORM\Column(name="comment", type="text", nullable=true) */
    protected ?string $comment = null;

    /** @ORM\Column(name="created_at", type="datetime", nullable=false) */
    protected ?DateTimeInterface $createdAt = null;

    /** @ORM\Column(name="updated_at", type="datetime", nullable=true) */
    protected ?DateTimeInterface $updatedAt = null;

    public function __construct()
    {
        $this->createdAt = new DateTime();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getQuoteInformation(): ?QuoteInformationInterface
    {
        return $this->quoteInformation;
    }

    public function setQuoteInformation(?QuoteInformationInterface $quoteInformation): self
    {
        $this->quoteInformation = $quoteInformation;

        return $this;
    }

    public function getUser(): ?AdminUserInterface
    {
        return $this->user;
    }

    public function setUser(?AdminUserInterface $user): self
    {
        $this->user = $user;

        return $this;
    }

    public function getCreatedAt(): ?DateTimeInterface
    {
        return $this->createdAt;
    }

    public function setCreatedAt(?DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    public function getUpdatedAt(): ?DateTimeInterface
    {
        return $this->updatedAt;
    }

    public function setUpdatedAt(?DateTimeInterface $updatedAt): self
    {
        $this->updatedAt = $updatedAt;

        return $this;
    }

    public function getComment(): ?string
    {
        return $this->comment;
    }

    public function setComment(?string $comment): self
    {
        $this->comment = $comment;

        return $this;
    }
}
